﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.IO;
using System.Collections.ObjectModel;

namespace PrintPreview
{
    public partial class ScalePrinterLayerProperty : Form
    {
        PrinterLayer layer = null;
        PrinterInteractiveOverLay overlay = null;
        GeoCollection<MapPrinterLayer> mapLayers = new GeoCollection<MapPrinterLayer>(); 

        public ScalePrinterLayerProperty(PrinterLayer layer, PrinterInteractiveOverLay overlay)
        {
            InitializeComponent();

            this.layer = layer;
            this.overlay = overlay;
        }


        private void Window_Load(object sender, EventArgs e)
        {
            LoadLayerProperties();
            LoadResize();
            LoadDrag();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            SetLayerProperties();
            SetResize();
            SetDrag();
            Close();

            DialogResult = DialogResult.OK;
        }

        private void LoadLayerProperties()
        {
            //foreach (PrinterLayer printerLayer in overlay .PrinterLayers)
            //{
            //    if (printerLayer .GetType () == typeof (MapPrinterLayer))
            //    {
            //        string fileName = ((ShapeFileFeatureLayer)((MapPrinterLayer)printerLayer).Layers[0]).ShapePathFileName;
            //        fileName = Path.GetFileNameWithoutExtension(fileName);
            //        cbxMap.Items.Add(fileName);
            //        mapLayers.Add(((MapPrinterLayer)printerLayer ).GetHashCode (), (MapPrinterLayer)printerLayer);
            //    }
           // }
        }

        private void SetLayerProperties()
        {
            //GeoImage image = new GeoImage(txtPath.Text);
            //layer.NeedleImage = image;

            //layer.Open();
            //PointShape centerPoint = layer.GetPosition().GetCenterPoint();
            //layer.SetPosition(image.GetWidth(), image.GetHeight(), centerPoint, PrintingUnit.Point);
        }

        private void LoadResize()
        {
            switch (layer.ResizeMode)
            {
                case PrinterResizeMode.Fixed:
                    rbtnResizeFixed.Checked = true;
                    break;
                case PrinterResizeMode.MaintainAspectRatio:
                    rbtnResizeMaintainRaio.Checked = true;
                    break;
                case PrinterResizeMode.Resizable:
                    rbtnResize.Checked = true;
                    break;
                default:
                    break;
            }
        }

        private void SetResize()
        {
            if (rbtnResize.Checked)
            {
                layer.ResizeMode = PrinterResizeMode.Resizable;
            }
            else if (rbtnResizeFixed.Checked)
            {
                layer.ResizeMode = PrinterResizeMode.Fixed;
            }
            else if (rbtnResizeMaintainRaio.Checked)
            {
                layer.ResizeMode = PrinterResizeMode.MaintainAspectRatio;
            }
        }

        private void LoadDrag()
        {
            switch (layer.DragMode)
            {
                case PrinterDragMode.Fixed:
                    rbtnDragFixed.Checked = true;
                    break;
                case PrinterDragMode.Draggable:
                    rbtnDraggable.Checked = true;
                    break;
                default:
                    break;
            }
        }

        private void SetDrag()
        {
            if (rbtnDragFixed.Checked)
            {
                layer.DragMode = PrinterDragMode.Fixed;
            }
            else if (rbtnDraggable.Checked)
            {
                layer.DragMode = PrinterDragMode.Draggable;
            }
        }


        private void btnBrowse_Click(object sender, EventArgs e)
        {
            //OpenFileDialog ofd = new OpenFileDialog();
            //ofd.Filter = "All files (*.*)|*.*";
            //ofd.RestoreDirectory = true;

            //if (ofd.ShowDialog() == DialogResult.OK)
            //{
            //    txtPath.Text = ofd.FileName;
            //}
        }
    }
}
